summaryrefslogtreecommitdiffstats
path: root/libraries/qt6
diff options
context:
space:
mode:
Diffstat (limited to 'libraries/qt6')
-rw-r--r--libraries/qt6/README39
-rw-r--r--libraries/qt6/README.SLACKWARE35
-rw-r--r--libraries/qt6/desktop/assistant-qt6.desktop8
-rw-r--r--libraries/qt6/desktop/designer-qt6.desktop10
-rw-r--r--libraries/qt6/desktop/linguist-qt6.desktop9
-rw-r--r--libraries/qt6/desktop/qdbusviewer-qt6.desktop9
-rw-r--r--libraries/qt6/doinst.sh9
-rw-r--r--libraries/qt6/newer_protobuf_1.patch58
-rw-r--r--libraries/qt6/newer_protobuf_2.patch42
-rw-r--r--libraries/qt6/profile.d/qt6.csh17
-rw-r--r--libraries/qt6/profile.d/qt6.sh17
-rw-r--r--libraries/qt6/qt6.SlackBuild197
-rw-r--r--libraries/qt6/qt6.info12
-rw-r--r--libraries/qt6/slack-desc19
14 files changed, 481 insertions, 0 deletions
diff --git a/libraries/qt6/README b/libraries/qt6/README
new file mode 100644
index 0000000000..b73df851a7
--- /dev/null
+++ b/libraries/qt6/README
@@ -0,0 +1,39 @@
+Qt is a cross-platform application development framework for desktop,
+embedded and mobile. Supported Platforms include Linux, OS X,
+Windows, VxWorks, QNX, Android, iOS, BlackBerry, Sailfish OS and
+others.
+
+Qt is not a programming language on its own. It is a framework written
+in C++. A preprocessor, the MOC (Meta-Object Compiler), is used to
+extend the C++ language with features like signals and slots. Before
+the compilation step, the MOC parses the source files written in
+Qt-extended C++ and generates standard compliant C++ sources from
+them. Thus the framework itself and applications/libraries using it
+can be compiled by any standard compliant C++ compiler like Clang,
+GCC, ICC, MinGW and MSVC.
+
+Qt6 has a compiler cache option when building. By default, this
+behavior is disabled. To enable it, pass CCACHE=ON to the build script.
+Unless you are building qt6 multiple times, you should leave this
+option OFF.
+
+Examples are disabled by default. To build them, pass EXAMPLES=ON
+to the build script.
+
+When building Qt's webengine, proprietary codecs are disabled by
+default. To enable them, pass PROPRIETARY_CODECS=ON to the build
+script. This will make the resulting package non-redistributable.
+
+Qt6 requires 16GB of RAM to build, and a minimum of 40GB of available
+disk storage. Disk storage requirements may increase when built
+against optional dependencies.
+
+Qt6 will autodetect and build against multiple external programs and
+libraries. To see a list of optional dependencies, please consult
+README.SLACKWARE
+
+Qt6 can take substantial time to build and ninja automatically uses
+all of your cpus power to speed up this process: if for some reason
+this ends up trashing the machine on which you are building it you
+can export the environment variable CMAKE_BUILD_PARALLEL_LEVEL to
+set an appropriate number of parallel jobs.
diff --git a/libraries/qt6/README.SLACKWARE b/libraries/qt6/README.SLACKWARE
new file mode 100644
index 0000000000..0c4a8679c3
--- /dev/null
+++ b/libraries/qt6/README.SLACKWARE
@@ -0,0 +1,35 @@
+Slackware 15.0's version of clang fails to compile qt6, due to the
+following error:
+
+Linking CXX executable qtbase/lib64/bin/lupdate
+/usr/bin/ld: CMakeFiles/lupdate.dir/cpp_clang.cpp.o: undefined
+ reference to symbol '_ZTIN5clang7tooling21FrontendActionFactoryE'
+/usr/bin/ld: /usr/lib64/libclangTooling.so.13: error adding symbols:
+ DSO missing from command line
+clang-13: error: linker command failed with exit code 1
+
+To remedy this, Qt provides a prebuilt clang package that we bootstrap
+against.
+
+Qt6 will compile with multiple optional dependencies, such as:
+
+ assimp
+ (*)db2
+ (*)cerence
+ (*)directfb
+ (*)gn
+ (*)interbase
+ libb2
+ (*)litehtml
+ (*)lttn-ust
+ mold
+ postgresql
+ (*)sensorfw
+ (*)s-log2
+ snappy
+ (*)tslib
+ xmlstarlet
+
+ ...and possibly others.
+
+(*) = not available from SBo at the time of writing.
diff --git a/libraries/qt6/desktop/assistant-qt6.desktop b/libraries/qt6/desktop/assistant-qt6.desktop
new file mode 100644
index 0000000000..32a48bd1cd
--- /dev/null
+++ b/libraries/qt6/desktop/assistant-qt6.desktop
@@ -0,0 +1,8 @@
+[Desktop Entry]
+Name=Qt6 Assistant
+Comment=Shows Qt6 documentation and examples
+Exec=/usr/lib@LIBDIR@/qt6/bin/assistant
+Icon=assistant-qt6
+Terminal=false
+Type=Application
+Categories=Qt;Development;Documentation;
diff --git a/libraries/qt6/desktop/designer-qt6.desktop b/libraries/qt6/desktop/designer-qt6.desktop
new file mode 100644
index 0000000000..3287bad25f
--- /dev/null
+++ b/libraries/qt6/desktop/designer-qt6.desktop
@@ -0,0 +1,10 @@
+[Desktop Entry]
+Name=Qt6 Designer
+GenericName=Interface Designer
+Comment=Design GUIs for Qt6 applications
+Exec=/usr/lib@LIBDIR@/qt6/bin/designer
+Icon=designer-qt6
+MimeType=application/x-designer;
+Terminal=false
+Type=Application
+Categories=Qt;Development;
diff --git a/libraries/qt6/desktop/linguist-qt6.desktop b/libraries/qt6/desktop/linguist-qt6.desktop
new file mode 100644
index 0000000000..837a24cf77
--- /dev/null
+++ b/libraries/qt6/desktop/linguist-qt6.desktop
@@ -0,0 +1,9 @@
+[Desktop Entry]
+Name=Qt6 Linguist
+Comment=Add translations to Qt6 applications
+Exec=/usr/lib@LIBDIR@/qt6/bin/linguist
+Icon=linguist-qt6
+MimeType=text/vnd.trolltech.linguist;application/x-linguist;
+Terminal=false
+Type=Application
+Categories=Qt;Development;
diff --git a/libraries/qt6/desktop/qdbusviewer-qt6.desktop b/libraries/qt6/desktop/qdbusviewer-qt6.desktop
new file mode 100644
index 0000000000..7ec65d117b
--- /dev/null
+++ b/libraries/qt6/desktop/qdbusviewer-qt6.desktop
@@ -0,0 +1,9 @@
+[Desktop Entry]
+Name=Qt6 QDbusViewer
+GenericName=Qt6 D-Bus Debugger
+Comment=Debug D-Bus applications
+Exec=/usr/lib@LIBDIR@/qt6/bin/qdbusviewer
+Icon=qdbusviewer-qt6
+Terminal=false
+Type=Application
+Categories=Qt;Development;Debugger;
diff --git a/libraries/qt6/doinst.sh b/libraries/qt6/doinst.sh
new file mode 100644
index 0000000000..65c7e2eeb9
--- /dev/null
+++ b/libraries/qt6/doinst.sh
@@ -0,0 +1,9 @@
+if [ -x /usr/bin/update-desktop-database ]; then
+ /usr/bin/update-desktop-database -q usr/share/applications >/dev/null 2>&1
+fi
+
+if [ -e usr/share/icons/hicolor/icon-theme.cache ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ /usr/bin/gtk-update-icon-cache -f usr/share/icons/hicolor >/dev/null 2>&1
+ fi
+fi
diff --git a/libraries/qt6/newer_protobuf_1.patch b/libraries/qt6/newer_protobuf_1.patch
new file mode 100644
index 0000000000..a5f24bf302
--- /dev/null
+++ b/libraries/qt6/newer_protobuf_1.patch
@@ -0,0 +1,58 @@
+Backported to 6.5.2 from 1a610ab9c7edde2e27ff707c9e534172e288e8ed in v6.7.0-beta1~260
+
+https://codereview.qt-project.org/gitweb?p=qt%2Fqtgrpc.git;a=commit;h=1a610ab9c7edde2e27ff707c9e534172e288e8ed
+
+diff -Naur qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtgrpcgen/clientdeclarationprinter.cpp qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtgrpcgen/clientdeclarationprinter.cpp
+--- qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtgrpcgen/clientdeclarationprinter.cpp 2023-07-07 14:29:20.000000000 +0200
++++ qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtgrpcgen/clientdeclarationprinter.cpp 2024-03-12 08:14:21.885741000 +0100
+@@ -8,7 +8,6 @@
+ #include <google/protobuf/io/printer.h>
+ #include <google/protobuf/io/zero_copy_stream.h>
+ #include <google/protobuf/stubs/common.h>
+-#include <google/protobuf/stubs/logging.h>
+
+ #include <string>
+ #include <unordered_set>
+diff -Naur qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtgrpcgen/qgrpcgenerator.cpp qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtgrpcgen/qgrpcgenerator.cpp
+--- qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtgrpcgen/qgrpcgenerator.cpp 2023-07-07 14:29:20.000000000 +0200
++++ qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtgrpcgen/qgrpcgenerator.cpp 2024-03-12 08:16:45.956741000 +0100
+@@ -12,11 +12,10 @@
+
+ #include <set>
+ #include <google/protobuf/compiler/code_generator.h>
+-#include <google/protobuf/stubs/logging.h>
+-#include <google/protobuf/stubs/common.h>
++#include <google/protobuf/descriptor.h>
+ #include <google/protobuf/io/printer.h>
+ #include <google/protobuf/io/zero_copy_stream.h>
+-#include <google/protobuf/descriptor.h>
++#include <google/protobuf/stubs/common.h>
+
+ using namespace ::QtGrpc;
+ using namespace ::qtprotoccommon;
+diff -Naur qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtprotobufgen/qprotobufgenerator.cpp qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtprotobufgen/qprotobufgenerator.cpp
+--- qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtprotobufgen/qprotobufgenerator.cpp 2023-07-07 14:29:20.000000000 +0200
++++ qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtprotobufgen/qprotobufgenerator.cpp 2024-03-12 08:17:09.574741000 +0100
+@@ -17,7 +17,6 @@
+ #include <array>
+ #include <numeric>
+ #include <set>
+-#include <google/protobuf/stubs/logging.h>
+ #include <google/protobuf/stubs/common.h>
+ #include <google/protobuf/io/printer.h>
+ #include <google/protobuf/io/zero_copy_stream.h>
+diff -Naur qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtprotoccommon/generatorbase.cpp qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtprotoccommon/generatorbase.cpp
+--- qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtprotoccommon/generatorbase.cpp 2023-07-07 14:29:20.000000000 +0200
++++ qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtprotoccommon/generatorbase.cpp 2024-03-12 08:18:20.905741000 +0100
+@@ -5,10 +5,9 @@
+ #include "generatorbase.h"
+
+ #include <google/protobuf/descriptor.h>
+-#include <google/protobuf/stubs/logging.h>
+-#include <google/protobuf/stubs/common.h>
+ #include <google/protobuf/io/printer.h>
+ #include <google/protobuf/io/zero_copy_stream.h>
++#include <google/protobuf/stubs/common.h>
+
+ #include "utils.h"
+ #include "commontemplates.h"
diff --git a/libraries/qt6/newer_protobuf_2.patch b/libraries/qt6/newer_protobuf_2.patch
new file mode 100644
index 0000000000..cfd5277570
--- /dev/null
+++ b/libraries/qt6/newer_protobuf_2.patch
@@ -0,0 +1,42 @@
+Backported to 6.5.2 from 2297f2da520b7eebe10dd6b5304e5a4c3c18a57c in v6.7.0-beta1~220
+
+https://codereview.qt-project.org/gitweb?p=qt/qtgrpc.git;a=commit;h=2297f2da520b7eebe10dd6b5304e5a4c3c18a57c
+
+diff -Naur qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtgrpcgen/qgrpcgenerator.cpp qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtgrpcgen/qgrpcgenerator.cpp
+--- qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtgrpcgen/qgrpcgenerator.cpp 2023-07-07 14:29:20.000000000 +0200
++++ qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtgrpcgen/qgrpcgenerator.cpp 2024-03-12 08:40:27.884741000 +0100
+@@ -32,13 +32,9 @@
+ bool QGrpcGenerator::Generate(const FileDescriptor *file,
+ [[maybe_unused]] const std::string &parameter,
+ GeneratorContext *generatorContext,
+- std::string *error) const
++ [[maybe_unused]] std::string *error) const
+ {
+ assert(file != nullptr && generatorContext != nullptr);
+- if (file->syntax() != FileDescriptor::SYNTAX_PROTO3) {
+- *error = "Invalid proto used. qtgrpcgen only supports 'proto3' syntax";
+- return false;
+- }
+
+ return GenerateClientServices(file, generatorContext);
+ }
+diff -Naur qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtprotobufgen/qprotobufgenerator.cpp qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtprotobufgen/qprotobufgenerator.cpp
+--- qt-everywhere-src-6.5.2.orig/qtgrpc/src/tools/qtprotobufgen/qprotobufgenerator.cpp 2023-07-07 14:29:20.000000000 +0200
++++ qt-everywhere-src-6.5.2/qtgrpc/src/tools/qtprotobufgen/qprotobufgenerator.cpp 2024-03-12 08:42:48.976741000 +0100
+@@ -37,15 +37,10 @@
+ bool QProtobufGenerator::Generate(const FileDescriptor *file,
+ [[maybe_unused]] const std::string &parameter,
+ GeneratorContext *generatorContext,
+- std::string *error) const
++ [[maybe_unused]] std::string *error) const
+ {
+ assert(file != nullptr && generatorContext != nullptr);
+
+- if (file->syntax() != FileDescriptor::SYNTAX_PROTO3) {
+- *error = "Invalid proto used. qtprotobufgen only supports 'proto3' syntax";
+- return false;
+- }
+-
+ return GenerateMessages(file, generatorContext);
+ }
+
diff --git a/libraries/qt6/profile.d/qt6.csh b/libraries/qt6/profile.d/qt6.csh
new file mode 100644
index 0000000000..7764724e0d
--- /dev/null
+++ b/libraries/qt6/profile.d/qt6.csh
@@ -0,0 +1,17 @@
+#!/bin/csh
+# Environment path variables for the Qt package:
+if ( ! $?QT6DIR ) then
+ # It's best to use the generic directory to avoid
+ # compiling in a version-containing path:
+ if ( -d /usr/lib@LIBDIRSUFFIX@/qt6 ) then
+ setenv QT6DIR /usr/lib@LIBDIRSUFFIX@/qt6
+ else
+ # Find the newest Qt directory and set $QT6DIR to that:
+ foreach qtd ( /usr/lib@LIBDIRSUFFIX@/qt6-* )
+ if ( -d $qtd ) then
+ setenv QT6DIR $qtd
+ endif
+ end
+ endif
+endif
+set path = ( $path $QT6DIR/bin )
diff --git a/libraries/qt6/profile.d/qt6.sh b/libraries/qt6/profile.d/qt6.sh
new file mode 100644
index 0000000000..70ccbc2faf
--- /dev/null
+++ b/libraries/qt6/profile.d/qt6.sh
@@ -0,0 +1,17 @@
+#!/bin/sh
+# Environment variables for the Qt package.
+#
+# It's best to use the generic directory to avoid
+# compiling in a version-containing path:
+if [ -d /usr/lib@LIBDIRSUFFIX@/qt6 ]; then
+ QT6DIR=/usr/lib@LIBDIRSUFFIX@/qt6
+else
+ # Find the newest Qt directory and set $QT6DIR to that:
+ for qtd in /usr/lib@LIBDIRSUFFIX@/qt6-* ; do
+ if [ -d $qtd ]; then
+ QT6DIR=$qtd
+ fi
+ done
+fi
+PATH="$PATH:$QT6DIR/bin"
+export QT6DIR
diff --git a/libraries/qt6/qt6.SlackBuild b/libraries/qt6/qt6.SlackBuild
new file mode 100644
index 0000000000..92997fc905
--- /dev/null
+++ b/libraries/qt6/qt6.SlackBuild
@@ -0,0 +1,197 @@
+#!/bin/bash
+
+# Slackware build script for qt6
+
+# Copyright 2022-2023 Steven Voges <Oregon, USA>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=qt6
+SRCNAM=qt-everywhere-src
+VERSION=${VERSION:-6.5.2}
+BSCLANG=libclang-release_130-based-linux-Ubuntu20.04-gcc9.3-x86_64
+CCACHE=${CCACHE:-OFF}
+EXAMPLES=${EXAMPLES:-OFF}
+LINKED_OPENSSL=${LINKED_OPENSSL:-ON}
+PROPRIETARY_CODECS=${PROPRIETARY_CODECS:-OFF}
+SYSTEM_FFMPEG=${SYSTEM_FFMPEG:-ON}
+SYSTEM_HARFBUZZ=${SYSTEM_HARFBUZZ:-OFF} #Link against qt6's harfbuzz because Slackware 15.0's package is too old
+SYSTEM_SQLITE=${SYSTEM_SQLITE:-ON}
+SYSTEM_XCB_INPUT=${SYSTEM_XCB_INPUT:-ON}
+BUILD=${BUILD:-2}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.xz
+cd $SRCNAM-$VERSION
+bsdtar xvf $CWD/$BSCLANG.7z
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+patch -p1 < $CWD/newer_protobuf_1.patch
+patch -p1 < $CWD/newer_protobuf_2.patch
+
+#Fix compile on -current/gcc13+
+sed -i '54i #include <cstdint>' qt3d/src/3rdparty/assimp/src/code/AssetLib/FBX/FBXBinaryTokenizer.cpp
+
+export CC=clang
+export CXX=clang++
+export CFLAGS="$SLKCFLAGS"
+
+mkdir -p build
+cd build
+ cmake \
+ -G Ninja \
+ -Wno-dev \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DClang_DIR=$TMP/$SRCNAM-$VERSION/libclang/lib/cmake/clang \
+ -DFEATURE_openssl_linked=$LINKED_OPENSSL \
+ -DFEATURE_system_harfbuzz=$SYSTEM_HARFBUZZ \
+ -DFEATURE_system_sqlite=$SYSTEM_SQLITE \
+ -DFEATURE_system_xcb_xinput=$SYSTEM_XCB_INPUT \
+ -DFEATURE_webengine_proprietary_codecs=$PROPRIETARY_CODECS \
+ -DFEATURE_webengine_system_ffmpeg=$SYSTEM_FFMPEG \
+ -DFEATURE_webengine_system_re2=OFF \
+ -DINSTALL_ARCHDATADIR=./lib${LIBDIRSUFFIX} \
+ -DINSTALL_BINDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/bin \
+ -DINSTALL_DESCRIPTIONSDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/modules \
+ -DINSTALL_DOCDIR=./doc/$PRGNAM-$VERSION \
+ -DINSTALL_EXAMPLESDIR=./doc/$PRGNAM-$VERSION/examples \
+ -DINSTALL_INCLUDEDIR=./include/$PRGNAM \
+ -DINSTALL_LIBDIR=./lib${LIBDIRSUFFIX} \
+ -DINSTALL_LIBEXECDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/libexec \
+ -DINSTALL_MKSPECSDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/mkspecs \
+ -DINSTALL_PLUGINSDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/plugins \
+ -DINSTALL_QMLDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/qml \
+ -DINSTALL_TRANSLATIONSDIR=./share/$PRGNAM/translations \
+ -DINSTALL_TESTSDIR=./lib${LIBDIRSUFFIX}/$PRGNAM/tests \
+ -DQT_BUILD_EXAMPLES=$EXAMPLES \
+ -DQT_USE_CCACHE=$CCACHE \
+ -DCMAKE_BUILD_TYPE=Release ..
+ cmake --build .
+ DESTDIR=$PKG cmake --install . --strip
+cd ..
+
+rm -R $PKG/usr/lib$LIBDIRSUFFIX/cmake/Qt6/QtBuildInternals
+rmdir $PKG/usr/lib$LIBDIRSUFFIX/cmake/Qt6/ios
+rmdir $PKG/usr/lib$LIBDIRSUFFIX/cmake/Qt6/macos
+
+if [ -d "$PKG/usr/phrasebooks" ]; then
+ mv $PKG/usr/phrasebooks $PKG/usr/share/$PRGNAM/
+fi
+if [ -d "$PKG/usr/resources" ]; then
+ mv $PKG/usr/resources $PKG/usr/share/$PRGNAM/
+fi
+
+if [ "$EXAMPLES" = "ON" ]; then
+ find -L $PKG/usr/doc/$PRGNAM-$VERSION/examples \
+ -type d -exec chmod 755 {} \;
+ find -L $PKG/usr/doc/$PRGNAM-$VERSION/examples \
+ -type f -exec chmod 644 {} \;
+fi
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+for i in $CWD/desktop/*.desktop; do
+ install -D -m 0644 $i $PKG/usr/share/applications/$(basename $i)
+done
+sed -i "s|@LIBDIR@|$LIBDIRSUFFIX|" $PKG/usr/share/applications/*
+
+# Install symlinks to the Qt6 binaries in the $PATH (avoid the ones already ending in "6" or "cmake"):
+mkdir -p $PKG/usr/bin
+for FILE in $PKG/usr/lib${LIBDIRSUFFIX}/qt6/bin/* ; do
+ if ! [[ $FILE =~ (6$|cmake$) ]]; then
+ ln -s ../lib${LIBDIRSUFFIX}/qt6/bin/$(basename $FILE) $PKG/usr/bin/$(basename $FILE)-qt6
+ fi
+done
+
+install -D -m 0644 qttools/src/assistant/assistant/images/assistant-128.png \
+ $PKG/usr/share/icons/hicolor/128x128/apps/assistant-qt6.png
+install -D -m 0644 qttools/src/designer/src/designer/images/designer.png \
+ $PKG/usr/share/icons/hicolor/128x128/apps/designer-qt6.png
+install -D -m 0644 qttools/src/qdbus/qdbusviewer/images/qdbusviewer-128.png \
+ $PKG/usr/share/icons/hicolor/128x128/apps/qdbusviewer-qt6.png
+install -D -m 0644 qttools/src/linguist/linguist/images/icons/linguist-128-32.png \
+ $PKG/usr/share/icons/hicolor/128x128/apps/linguist-qt6.png
+
+mkdir -p $PKG/etc/profile.d
+sed -e "s|@LIBDIRSUFFIX@|${LIBDIRSUFFIX}|g" $CWD/profile.d/$PRGNAM.sh \
+ > $PKG/etc/profile.d/$PRGNAM.sh
+sed -e "s|@LIBDIRSUFFIX@|${LIBDIRSUFFIX}|g" $CWD/profile.d/$PRGNAM.csh \
+ > $PKG/etc/profile.d/$PRGNAM.csh
+chmod 0755 $PKG/etc/profile.d/*
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ .QT-ENTERPRISE-LICENSE-AGREEMENT LICENSE.* README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/qt6/qt6.info b/libraries/qt6/qt6.info
new file mode 100644
index 0000000000..5996f1a317
--- /dev/null
+++ b/libraries/qt6/qt6.info
@@ -0,0 +1,12 @@
+PRGNAM="qt6"
+VERSION="6.5.2"
+HOMEPAGE="https://qt.io"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://download.qt.io/official_releases/qt/6.5/6.5.2/single/qt-everywhere-src-6.5.2.tar.xz \
+ https://download.qt.io/development_releases/prebuilt/libclang/libclang-release_130-based-linux-Ubuntu20.04-gcc9.3-x86_64.7z"
+MD5SUM_x86_64="87f56fd8aedd2e429047c40397e9be48 \
+ 1eb94ba35df4aa217cf485086215182a"
+REQUIRES="double-conversion html5lib md4c nodejs"
+MAINTAINER="Steven Voges"
+EMAIL="svoges.sbo@gmail.com"
diff --git a/libraries/qt6/slack-desc b/libraries/qt6/slack-desc
new file mode 100644
index 0000000000..32c3c86424
--- /dev/null
+++ b/libraries/qt6/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+qt6: qt6 (Application Development Framework)
+qt6:
+qt6: Qt is a cross-platform application development framework for desktop,
+qt6: embedded and mobile. Supported Platforms include Linux, OS X,
+qt6: Windows, VxWorks, QNX, Android, iOS, BlackBerry, Sailfish OS and
+qt6: others.
+qt6:
+qt6: Homepage: https://qt.io
+qt6:
+qt6:
+qt6: